### Virtual Method

# EDataCal CalMetaBackend search_sync

since: 3.26

#### Declaration [src]

    gboolean
    search_sync (
      ECalMetaBackend* meta_backend,
      const gchar* expr,
      GSList** out_icalstrings,
      GCancellable* cancellable,
      GError** error
    )

#### Description [src]

Searches `meta_backend` with given expression `expr` and returns found components as a `GSList` of iCal strings `out_icalstrings`. Free the returned `out_icalstrings` with g_slist_free_full (icalstrings, g_free); when no longer needed. When the `expr` is `NULL`, all objects are returned. To get `ECalComponent`-s instead, call e_cal_meta_backend_search_components_sync().

It is optional to implement this virtual method by the descendant. The default implementation searches `meta_backend`‘s cache. It’s also not required to be online for searching, thus `meta_backend` doesn’t ensure it.

Available since: 3.26

#### Parameters

`expr`

  Type: `const gchar*`

  A search expression, or `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the method.
  The value is a NUL terminated UTF-8 string.

`out_icalstrings`

  Type: A list of `utf8`

  Return location for the found components as iCal strings.

  The argument will be set by the function.
  The caller of the method takes ownership of the returned data, and is responsible for freeing it.
  Each element is a NUL terminated UTF-8 string.

`cancellable`

  Type: `GCancellable`

  Optional `GCancellable` object, or `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the virtual function if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gboolean`

Whether succeeded.